#CaV current model simulation
import math

#put a text file at the same directory providing the voltage commmands at the path as following:
path = 'Vcommand.txt'

# initial dt value setting (just for in case)
dt = 0.01
# parameters for modeling
alpha = 0.2
VCaV_50 = -17
ECa = 60
k_on = 0.55
k_off = 0.65

for i in range(12):
	column = int(i+1)
	DATA =  "t, Vm, ICa_rel, Ps_act, PCaV_op, Pd, Pc, Pb, P_inact, \n"
	count = 0
	Ps_act = 0.0594
#
	with open(path) as f_in:
		for line in f_in:
			text = line.split()
			t = float(text[0])
			print(count)
			if count == 1: dt = t			
			count = count + 1
			
			Vm = float(text[column])
			CaV_op_st = 1/(1+math.exp(-alpha*(Vm-VCaV_50)))
			Ps_act_st = CaV_op_st**0.25
			if Ps_act > Ps_act_st: v = k_off * (1 - Ps_act_st)
			else: v = k_on * Ps_act_st
			Ps_act = Ps_act+ dt*v*(Ps_act_st - Ps_act)
			PCaV_op = Ps_act**4
			ICa_rel = PCaV_op*(Vm - ECa)
			Pd = 4*(Ps_act**3)*(1-Ps_act)
			Pc = 6*(Ps_act**2)*((1-Ps_act)**2)
			Pb = 4*(Ps_act**1)*((1-Ps_act)**3)
			P_inact = (1-Ps_act)**4
			DATA_t = str(t) + ", " + str(Vm) + ", " + str(ICa_rel) + ", "+ str(Ps_act) + ", "+ str(PCaV_op) + ", "+ str(Pd) + ", "+ str(Pc) + ", "+ str(Pb) + ", " + str(P_inact)
			DATA = DATA + DATA_t + "\n" 
			
#file output of simulated Cav activation
	outputfile = "sim_result" + str(column) + ".csv"
	with open(outputfile, mode = "w") as f_out:
		f_out.write(DATA)
		
	
